clearvars; close all; clc;

varNoise = .0005;
vLengthsc = 1.;
hLengthsc = 1.;

nTest = 100;
nTraining = 5;


xTest = linspace(-5,5,nTest)';
yTrue = sin(0.9*xTest);

indexTraining = round(nTest*rand(nTraining,1));
xTraining = xTest(indexTraining,:);
yTraining = yTrue(indexTraining,:) + varNoise^.5*randn(nTraining,1);

K_SE = @(x1,x2,vLengthscale,hLengthscale) (vLengthscale^2*exp((-.5/(hLengthscale^2))*(repmat(transpose(x1),size(x2)) - repmat(x2,size(transpose(x1)))).^2));
    
for iter=1:25
    K_trainTrain = K_SE(xTraining,xTraining,vLengthsc,hLengthsc) + varNoise*eye(nTraining);
    K_trainTest = K_SE(xTraining,xTest,vLengthsc,hLengthsc);
    K_testTrain = K_trainTest';
    K_testTest = K_SE(xTest,xTest,vLengthsc,hLengthsc);

    meanTest = K_trainTest*(K_trainTrain\yTraining); 
    meanTest = meanTest';

    covTest = K_testTest + varNoise - K_trainTest*(K_trainTrain\K_testTrain);
    stdTest = diag(covTest).^.5;
    stdTest = stdTest';

    clf('reset');
    figure(1)
    h = zeros(1, 4);
    s = cell(1, 4);
    s{1}='prediction (2 std)';
    s{2}='true function';
    s{3}='training data';
    s{4}='next data point';

    hold on;
    h(1) = plot(xTest,meanTest,'k');
    shadedErrorBar(xTest,meanTest,2*stdTest);
    h(2) = plot(xTest,yTrue,'r');
    h(3) = plot(xTraining,yTraining,'bx');
    h(4) = plot(-10,0,'go','LineWidth',4);
    axis([-5 5 -2.5 2.5])
    legend(h,s,'Orientation','horizontal','Location','SouthOutside');
    xlabel('x');
    ylabel('y');
    
    [dummy, indexAdd] = max(stdTest);
    nTraining = nTraining+1;
    xTraining = [xTraining; xTest(indexAdd(1),:)];
    yTraining = [yTraining; yTrue(indexAdd(1),:) + varNoise^.5*randn(1,1)];
            
    if iter<7
        disp('Hit any key to continue ...'); pause;
        plot(xTest(indexAdd(1),:),0,'go','LineWidth',4);
        legend(h,s,'Orientation','horizontal','Location','SouthOutside');
        disp('Hit any key to continue ...'); pause;
    end
end



